diff -crN nakedmudv1.0/src/handler.c nakedmudv1.4/src/handler.c
*** nakedmudv1.0/src/handler.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/handler.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 21,27 ****
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  
--- 21,27 ----
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
  
***************
*** 370,376 ****
  bool try_unequip(CHAR_DATA *ch, OBJ_DATA *obj) {
    if(bodyUnequip(charGetBody(ch), obj)) {
      objSetWearer(obj, NULL);
!      //*******************************
      // remove all of the item affects
      //*******************************
      return TRUE;
--- 370,376 ----
  bool try_unequip(CHAR_DATA *ch, OBJ_DATA *obj) {
    if(bodyUnequip(charGetBody(ch), obj)) {
      objSetWearer(obj, NULL);
!     //*******************************
      // remove all of the item affects
      //*******************************
      return TRUE;
***************
*** 481,487 ****
      count += count_objs(looker, equipment, at, NOTHING,
  			(IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_OBJ;
        OBJ_DATA *obj = find_obj(looker, equipment, at_count, at, NOTHING, 
  			       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
        deleteList(equipment);
--- 481,488 ----
      count += count_objs(looker, equipment, at, NOTHING,
  			(IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_OBJ;
        OBJ_DATA *obj = find_obj(looker, equipment, at_count, at, NOTHING, 
  			       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
        deleteList(equipment);
***************
*** 496,502 ****
    // FINISH ME
    //***********
  
!   *found_type = FOUND_NONE;
    return NULL;
  }
  
--- 497,504 ----
    // FINISH ME
    //***********
  
!   if(found_type)
!     *found_type = FOUND_NONE;
    return NULL;
  }
  
***************
*** 517,523 ****
      count = count_chars(looker, objGetUsers(on), at, NOBODY,
  			(IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_CHAR;
        return find_char(looker, objGetUsers(on), at_count, at, NOBODY,
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
--- 519,526 ----
      count = count_chars(looker, objGetUsers(on), at, NOBODY,
  			(IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_CHAR;
        return find_char(looker, objGetUsers(on), at_count, at, NOBODY,
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
***************
*** 529,542 ****
    if(IS_SET(find_types, FIND_TYPE_EDESC)) {
      count = (objGetEdesc(on, at) != NULL);
      if(count && at_count == 1) {
!       *found_type = FOUND_EDESC;
        return getEdesc(objGetEdescs(on), at);
      }
      else
        at_count--;
    }
! 
!   *found_type = FOUND_NONE;
    return NULL;
  }
  
--- 532,547 ----
    if(IS_SET(find_types, FIND_TYPE_EDESC)) {
      count = (objGetEdesc(on, at) != NULL);
      if(count && at_count == 1) {
!       if(found_type)
! 	*found_type = FOUND_EDESC;
        return getEdesc(objGetEdescs(on), at);
      }
      else
        at_count--;
    }
!  
!   if(found_type)
!     *found_type = FOUND_NONE;
    return NULL;
  }
  
***************
*** 551,557 ****
  		  bitvector_t find_types,
  		  bitvector_t find_scope,
  		  int *found_type) {		  
!   *found_type = FOUND_NONE;
  
    // see if we're looking on anything
    if(on && *on && on_count > 0) {
--- 556,563 ----
  		  bitvector_t find_types,
  		  bitvector_t find_scope,
  		  int *found_type) {		  
!   if(found_type)
!     *found_type = FOUND_NONE;
  
    // see if we're looking on anything
    if(on && *on && on_count > 0) {
***************
*** 567,573 ****
      int count = count_objs(looker, objGetContents(in), at, NOTHING,
  			    (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_OBJ;
        return find_obj(looker, objGetContents(in), at_count, at, NOTHING,
  		      (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
--- 573,580 ----
      int count = count_objs(looker, objGetContents(in), at, NOTHING,
  			    (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_OBJ;
        return find_obj(looker, objGetContents(in), at_count, at, NOTHING,
  		      (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
***************
*** 579,585 ****
  
  LIST *find_all(CHAR_DATA *looker, const char *at, bitvector_t find_types,
  	       bitvector_t find_scope, int *found_type) {
!   *found_type = FOUND_LIST;
  
    /************************************************************/
    /*                        FIND ALL OBJS                     */
--- 586,593 ----
  
  LIST *find_all(CHAR_DATA *looker, const char *at, bitvector_t find_types,
  	       bitvector_t find_scope, int *found_type) {
!   if(found_type)
!     *found_type = FOUND_LIST;
  
    /************************************************************/
    /*                        FIND ALL OBJS                     */
***************
*** 638,644 ****
      // if we didn't find anything, return NULL
      if(listSize(obj_list) < 1) {
        deleteList(obj_list);
!       *found_type = FOUND_NONE;
        return NULL;
      }
      else
--- 646,653 ----
      // if we didn't find anything, return NULL
      if(listSize(obj_list) < 1) {
        deleteList(obj_list);
!       if(found_type)
! 	*found_type = FOUND_NONE;
        return NULL;
      }
      else
***************
*** 650,656 ****
    /*                        FIND ALL CHARS                    */
    /************************************************************/
    else if(find_types == FIND_TYPE_CHAR) {
!     *found_type = FOUND_NONE;
      return NULL;
    }
    
--- 659,666 ----
    /*                        FIND ALL CHARS                    */
    /************************************************************/
    else if(find_types == FIND_TYPE_CHAR) {
!     if(found_type)
!       *found_type = FOUND_NONE;
      return NULL;
    }
    
***************
*** 659,665 ****
    /*                       FIND ALL EDESCS                    */
    /************************************************************/
    else {
!     *found_type = FOUND_NONE;
      return NULL;
    }
  }
--- 669,676 ----
    /*                       FIND ALL EDESCS                    */
    /************************************************************/
    else {
!     if(found_type)
!       *found_type = FOUND_NONE;
      return NULL;
    }
  }
***************
*** 682,688 ****
       at_count >= 1 && !strcasecmp(at, "self")) {
      at_count--;
      if(at_count == 0) {
!       *found_type = FOUND_CHAR;
        return looker;
      }
    }
--- 693,700 ----
       at_count >= 1 && !strcasecmp(at, "self")) {
      at_count--;
      if(at_count == 0) {
!       if(found_type)
! 	*found_type = FOUND_CHAR;
        return looker;
      }
    }
***************
*** 693,699 ****
      count = count_objs(looker, charGetInventory(looker), at, NOTHING, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_OBJ;
        return find_obj(looker, charGetInventory(looker), at_count, at, NOTHING,
  		      (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
--- 705,712 ----
      count = count_objs(looker, charGetInventory(looker), at, NOTHING, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_OBJ;
        return find_obj(looker, charGetInventory(looker), at_count, at, NOTHING,
  		      (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
***************
*** 708,714 ****
      count = count_objs(looker, equipment, at, NOTHING, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_OBJ;
        OBJ_DATA *obj = find_obj(looker, equipment, at_count, at, NOTHING, 
  			       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
        deleteList(equipment);
--- 721,728 ----
      count = count_objs(looker, equipment, at, NOTHING, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_OBJ;
        OBJ_DATA *obj = find_obj(looker, equipment, at_count, at, NOTHING, 
  			       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
        deleteList(equipment);
***************
*** 730,736 ****
      count = count_objs(looker, roomGetContents(charGetRoom(looker)), at, 
  		       NOTHING, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       *found_type = FOUND_OBJ;
        return find_obj(looker, roomGetContents(charGetRoom(looker)), at_count,
  		      at, NOTHING, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
--- 744,751 ----
      count = count_objs(looker, roomGetContents(charGetRoom(looker)), at, 
  		       NOTHING, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
!       if(found_type)
! 	*found_type = FOUND_OBJ;
        return find_obj(looker, roomGetContents(charGetRoom(looker)), at_count,
  		      at, NOTHING, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
***************
*** 744,753 ****
      count = count_chars(looker, roomGetCharacters(charGetRoom(looker)), at,
  		       NOBODY, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
  	*found_type = FOUND_CHAR;
! 	return find_char(looker, roomGetCharacters(charGetRoom(looker)), 
! 			 at_count, at, NOBODY,
! 			 (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
--- 759,769 ----
      count = count_chars(looker, roomGetCharacters(charGetRoom(looker)), at,
  		       NOBODY, (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
+       if(found_type)
  	*found_type = FOUND_CHAR;
!       return find_char(looker, roomGetCharacters(charGetRoom(looker)), 
! 		       at_count, at, NOBODY,
! 		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
***************
*** 778,784 ****
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  *found_type = FOUND_EXIT;
  	  return exit;
  	}
      }
--- 794,801 ----
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  if(found_type)
! 	    *found_type = FOUND_EXIT;
  	  return exit;
  	}
      }
***************
*** 802,808 ****
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  *found_type = FOUND_EXIT;
  	  return exit;
  	}
        }
--- 819,826 ----
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  if(found_type)
! 	    *found_type = FOUND_EXIT;
  	  return exit;
  	}
        }
***************
*** 822,828 ****
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  *found_type = FOUND_EXIT;
  	  // don't return it yet... we need to clean up our mess
  	  break;
  	}
--- 840,847 ----
  	  can_see_exit(looker, exit))) {
  	at_count--;
  	if(at_count == 0) {
! 	  if(found_type)
! 	    *found_type = FOUND_EXIT;
  	  // don't return it yet... we need to clean up our mess
  	  break;
  	}
***************
*** 851,858 ****
       IS_SET(find_types, FIND_TYPE_EDESC)) {
      count = (roomGetEdesc(charGetRoom(looker), at) != NULL);
      if(count && at_count == 1) {
  	*found_type = FOUND_EDESC;
! 	return getEdesc(roomGetEdescs(charGetRoom(looker)), at);
      }
      else
  	at_count--;
--- 870,878 ----
       IS_SET(find_types, FIND_TYPE_EDESC)) {
      count = (roomGetEdesc(charGetRoom(looker), at) != NULL);
      if(count && at_count == 1) {
+       if(found_type)
  	*found_type = FOUND_EDESC;
!       return getEdesc(roomGetEdescs(charGetRoom(looker)), at);
      }
      else
  	at_count--;
***************
*** 868,876 ****
      count = count_objs(looker, object_list, at, NOTHING, 
  			 (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
  	*found_type = FOUND_OBJ;
! 	return find_obj(looker, object_list, at_count, at, NOTHING, 
! 			(IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
--- 888,897 ----
      count = count_objs(looker, object_list, at, NOTHING, 
  			 (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
+       if(found_type)
  	*found_type = FOUND_OBJ;
!       return find_obj(looker, object_list, at_count, at, NOTHING, 
! 		      (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
***************
*** 882,897 ****
      count = count_chars(looker, mobile_list, at, NOBODY, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
  	*found_type = FOUND_CHAR;
! 	return find_char(looker, mobile_list, at_count, at, NOBODY,
! 			 (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
    }
  
    // we didn't find anything!
!   *found_type = FOUND_NONE;
    return NULL;
  }
  
--- 903,920 ----
      count = count_chars(looker, mobile_list, at, NOBODY, 
  		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      if(count >= at_count) {
+       if(found_type)
  	*found_type = FOUND_CHAR;
!       return find_char(looker, mobile_list, at_count, at, NOBODY,
! 		       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
      }
      else
  	at_count -= count;
    }
  
    // we didn't find anything!
!   if(found_type)
!     *found_type = FOUND_NONE;
    return NULL;
  }
  
***************
*** 964,970 ****
    get_count(in, in, &in_count);
    get_count(on, on, &on_count);
  
!   *found_type = FOUND_NONE;
  
  
    // are we trying to find all of something?
--- 987,994 ----
    get_count(in, in, &in_count);
    get_count(on, on, &on_count);
  
!   if(found_type)
!     *found_type = FOUND_NONE;
  
  
    // are we trying to find all of something?
***************
*** 998,1010 ****
  	return NULL;
        // return what we found
        else {
! 	*found_type = FOUND_IN_OBJ;
  	return tgt;
        }
      }
      // we're just not looking for anything
      else {
!       *found_type = FOUND_NONE;
        return NULL;
      }
    }
--- 1022,1036 ----
  	return NULL;
        // return what we found
        else {
! 	if(found_type)
! 	  *found_type = FOUND_IN_OBJ;
  	return tgt;
        }
      }
      // we're just not looking for anything
      else {
!       if(found_type)
! 	*found_type = FOUND_NONE;
        return NULL;
      }
    }
diff -crN nakedmudv1.0/src/hashtable.c nakedmudv1.4/src/hashtable.c
*** nakedmudv1.0/src/hashtable.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/hashtable.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 8,14 ****
  //*****************************************************************************
  
  #include <stdlib.h>
! #include <strings.h>
  #include "list.h"
  #include "hashtable.h"
  
--- 8,14 ----
  //*****************************************************************************
  
  #include <stdlib.h>
! #include <string.h>
  #include "list.h"
  #include "hashtable.h"
  
diff -crN nakedmudv1.0/src/help.c nakedmudv1.4/src/help.c
*** nakedmudv1.0/src/help.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/help.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,21 ****
--- 16,22 ----
  /* include main header file */
  #include "mud.h"
  #include "character.h"
+ #include "help.h"
  
  HELP_DATA   *   help_list = NULL; /* the linked list of help files     */
  char        *   greeting;         /* the welcome greeting              */
***************
*** 123,133 ****
      new_help->text       =  strdup(s);
      new_help->load_time  =  time(NULL);
      add_help(new_help);
- 
-     if (compares("GREETING", new_help->keyword))
-       greeting = new_help->text;
-     else if (compares("MOTD", new_help->keyword))
-       motd = new_help->text;
    }
    closedir(directory);
  }
--- 124,129 ----
diff -crN nakedmudv1.0/src/inform.c nakedmudv1.4/src/inform.c
*** nakedmudv1.0/src/inform.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/inform.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 22,32 ****
  #include "handler.h"
  #include "socket.h"
  #include "inform.h"
  
  
  // optional module headers
  #ifdef MODULE_TIME
! #include "modules/time/mudtime.h"
  #endif
  
  
--- 22,33 ----
  #include "handler.h"
  #include "socket.h"
  #include "inform.h"
+ #include "log.h"
  
  
  // optional module headers
  #ifdef MODULE_TIME
! #include "time/mudtime.h"
  #endif
  
  
***************
*** 79,85 ****
      // don't show ourself
      if(i == ch && !include_self) continue;
      // check for invis and hidden ...
!     if(!(invis_ok || can_see_person(ch, i)))
        continue;
      // make sure they're not on furniture
      if(charGetFurniture(i))
--- 80,86 ----
      // don't show ourself
      if(i == ch && !include_self) continue;
      // check for invis and hidden ...
!     if(!(invis_ok || can_see_char(ch, i)))
        continue;
      // make sure they're not on furniture
      if(charGetFurniture(i))
***************
*** 315,320 ****
--- 316,410 ----
  }
  
  
+ void text_to_char(CHAR_DATA *ch, const char *txt) {
+   if (txt && *txt && charGetSocket(ch) && 
+       socketGetState(charGetSocket(ch)) == STATE_PLAYING) {
+     text_to_buffer(charGetSocket(ch), txt);
+     charGetSocket(ch)->bust_prompt = TRUE;
+   }
+ 
+   // if it's a PC or we are not in game, then
+   // don't send the mesage to us
+   if(!charIsNPC(ch))
+     try_log(charGetName(ch), txt);
+ }
+ 
+ 
+ void send_to_char(CHAR_DATA *ch, const char *format, ...) {
+   if(charGetSocket(ch) && format && *format) {
+     static char buf[MAX_BUFFER];
+     va_list args;
+     va_start(args, format);
+     vsprintf(buf, format, args);
+     va_end(args);
+     text_to_char(ch, buf);
+     return;
+   }
+ }
+ 
+ 
+ void send_around_char(CHAR_DATA *ch, bool hide_nosee, const char *format, ...) {
+   static char buf[MAX_BUFFER];
+   va_list args;
+   va_start(args, format);
+   vsprintf(buf, format, args);
+   va_end(args);
+ 
+   LIST_ITERATOR *room_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
+   CHAR_DATA       *vict = NULL;
+ 
+   ITERATE_LIST(vict, room_i) {
+     if(ch == vict)
+       continue;
+     if(hide_nosee && !can_see_char(vict, ch))
+       continue;
+     text_to_char(vict, buf);
+   }
+   deleteListIterator(room_i);
+   return;
+ }
+ 
+ 
+ void send_to_level(int level, const char *format, ...) {
+   static char buf[MAX_BUFFER];
+   va_list args;
+   va_start(args, format);
+   vsprintf(buf, format, args);
+   va_end(args);
+ 
+   LIST_ITERATOR *ch_i = newListIterator(mobile_list);
+   CHAR_DATA       *ch = NULL;
+ 
+   ITERATE_LIST(ch, ch_i) {
+     if(!charGetSocket(ch) || charGetLevel(ch) < level)
+       continue;
+     text_to_char(ch, buf);
+   }
+   deleteListIterator(ch_i);
+ }
+ 
+ 
+ void send_to_list(LIST *list, const char *format, ...) {
+   if(format && *format) {
+     // form the message
+     static char buf[MAX_BUFFER];
+     va_list args;
+     va_start(args, format);
+     vsprintf(buf, format, args);
+     va_end(args);
+ 
+     // send it out to everyone
+     LIST_ITERATOR *list_i = newListIterator(list);
+     CHAR_DATA *ch = NULL;
+     ITERATE_LIST(ch, list_i)
+       text_to_char(ch, buf);
+     deleteListIterator(list_i);
+   }
+ };
+ 
+ 
+ 
+ 
  //*****************************************************************************
  //
  // commands included in inform.c
***************
*** 460,466 ****
  // show a list of all commands available to the character
  //
  COMMAND(cmd_commands) {
!   show_commands(ch);
  }
  
  
--- 550,556 ----
  // show a list of all commands available to the character
  //
  COMMAND(cmd_commands) {
!   show_commands(ch, LEVEL_PLAYER, charGetLevel(ch));
  }
  
  
***************
*** 534,540 ****
  }
  
  
- 
  //*****************************************************************************
  //
  // below this line are all of the subfunctions related to the message() 
--- 624,629 ----
***************
*** 583,638 ****
        switch(str[i]) {
        case 'n':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_person(to, ch)?charGetName(ch):SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'N':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_person(to, vict)?charGetName(vict):SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'm':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_person(to, ch) ? HIMHER(ch) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'M':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_person(to, vict) ? HIMHER(vict) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 's':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_person(to, ch) ? HISHERS(ch) : SOMEONE"s"));
  	while(buf[j] != '\0') j++;
  	break;
        case 'S':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_person(to, vict) ? HISHERS(vict) : SOMEONE"s"));
  	while(buf[j] != '\0') j++;
  	break;
        case 'e':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_person(to, ch) ? HESHE(ch) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'E':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_person(to, vict) ? HESHE(vict) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'o':
  	if(!obj) break;
! 	sprintf(buf+j, (can_see_obj(to, obj) ? objGetName(obj) : SOMETHING));
  	while(buf[j] != '\0') j++;
  	break;
        case 'O':
  	if(!vobj) break;
! 	sprintf(buf+j, (can_see_obj(to, vobj) ? objGetName(vobj) : SOMETHING));
  	while(buf[j] != '\0') j++;
  	break;
        case 'a':
        case 'A':
        case '$':
  	buf[j] = '$';
  	j++;
--- 672,735 ----
        switch(str[i]) {
        case 'n':
  	if(!ch) break;
! 	sprintf(buf+j, see_char_as(to, ch));
  	while(buf[j] != '\0') j++;
  	break;
        case 'N':
  	if(!vict) break;
! 	sprintf(buf+j, see_char_as(to, vict));
  	while(buf[j] != '\0') j++;
  	break;
        case 'm':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_char(to, ch) ? HIMHER(ch) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'M':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_char(to, vict) ? HIMHER(vict) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 's':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_char(to, ch) ? HISHERS(ch) :SOMEONE"'s"));
  	while(buf[j] != '\0') j++;
  	break;
        case 'S':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_char(to, vict) ? HISHERS(vict) :SOMEONE"'s"));
  	while(buf[j] != '\0') j++;
  	break;
        case 'e':
  	if(!ch) break;
! 	sprintf(buf+j, (can_see_char(to, ch) ? HESHE(ch) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'E':
  	if(!vict) break;
! 	sprintf(buf+j, (can_see_char(to, vict) ? HESHE(vict) : SOMEONE));
  	while(buf[j] != '\0') j++;
  	break;
        case 'o':
  	if(!obj) break;
! 	sprintf(buf+j, see_obj_as(to, obj));
  	while(buf[j] != '\0') j++;
  	break;
        case 'O':
  	if(!vobj) break;
! 	sprintf(buf+j, see_obj_as(to, vobj));
  	while(buf[j] != '\0') j++;
  	break;
        case 'a':
+ 	if(!obj) break;
+ 	sprintf(buf+j, AN(see_obj_as(to, obj)));
+ 	while(buf[j] != '\0') j++;
+ 	break;
        case 'A':
+ 	if(!vobj) break;
+ 	sprintf(buf+j, AN(see_obj_as(to, vobj)));
+ 	while(buf[j] != '\0') j++;
+ 	break;
        case '$':
  	buf[j] = '$';
  	j++;
***************
*** 645,681 ****
  
    //  buf[0] = toupper(buf[0]);
    sprintf(buf+j, "\r\n");
!   send_to_char(to, buf);
  }
  
  
  void message(CHAR_DATA *ch,  CHAR_DATA *vict,
  	     OBJ_DATA  *obj, OBJ_DATA  *vobj,
  	     int hide_nosee, bitvector_t range, 
! 	     const char *format, ...) {
!   static char buf[MAX_BUFFER];
!   va_list args;
! 
!   if(!format || !*format)
      return;
  
-   va_start(args, format);
-   vsprintf(buf, format, args);
-   va_end(args);
- 
    // what's our scope?
    if(IS_SET(range, TO_VICT) &&
       (!hide_nosee ||
        // make sure the vict can the character, or the
        // object if there is no character
!       ((!ch || can_see_person(vict, ch)) &&
         (ch  || (!obj || can_see_obj(vict, obj))))))
!     send_message(vict, buf, ch, vict, obj, vobj);
    // characters can always see themselves. No need to do checks here
    else if(IS_SET(range, TO_CHAR))
!     send_message(ch, buf, ch, vict, obj, vobj);
    else {
- 
      LIST *recipients = NULL;
      // check if the scope of this message is everyone in the world
      if(IS_SET(range, TO_WORLD))
--- 742,770 ----
  
    //  buf[0] = toupper(buf[0]);
    sprintf(buf+j, "\r\n");
!   text_to_char(to, buf);
  }
  
  
  void message(CHAR_DATA *ch,  CHAR_DATA *vict,
  	     OBJ_DATA  *obj, OBJ_DATA  *vobj,
  	     int hide_nosee, bitvector_t range, 
! 	     const char *mssg) {
!   if(!mssg || !*mssg)
      return;
  
    // what's our scope?
    if(IS_SET(range, TO_VICT) &&
       (!hide_nosee ||
        // make sure the vict can the character, or the
        // object if there is no character
!       ((!ch || can_see_char(vict, ch)) &&
         (ch  || (!obj || can_see_obj(vict, obj))))))
!     send_message(vict, mssg, ch, vict, obj, vobj);
    // characters can always see themselves. No need to do checks here
    else if(IS_SET(range, TO_CHAR))
!     send_message(ch, mssg, ch, vict, obj, vobj);
    else {
      LIST *recipients = NULL;
      // check if the scope of this message is everyone in the world
      if(IS_SET(range, TO_WORLD))
***************
*** 696,704 ****
  	 (!hide_nosee ||
  	  // make sure the vict can see the character, or the
  	  // object if there is no character
! 	  ((!ch || can_see_person(rec, ch)) &&
  	   (ch  || (!obj || can_see_obj(rec, obj))))))
!       send_message(rec, buf, ch, vict, obj, vobj);
      }
      deleteListIterator(rec_i);
    }
--- 785,793 ----
  	 (!hide_nosee ||
  	  // make sure the vict can see the character, or the
  	  // object if there is no character
! 	  ((!ch || can_see_char(rec, ch)) &&
  	   (ch  || (!obj || can_see_obj(rec, obj))))))
!       send_message(rec, mssg, ch, vict, obj, vobj);
      }
      deleteListIterator(rec_i);
    }
diff -crN nakedmudv1.0/src/inform.h nakedmudv1.4/src/inform.h
*** nakedmudv1.0/src/inform.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/inform.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 44,68 ****
  void message(CHAR_DATA *ch,  CHAR_DATA *vict,
  	     OBJ_DATA  *obj, OBJ_DATA  *vobj,
  	     int hide_nosee, bitvector_t range, 
! 	     const char *format, ...);
  
  
  //
  // send a message to everyone outdoors
  //
! void  send_outdoors(const char *format, ...);
  
  
  //
  // send a message to a list of characters
  //
! void  send_to_list (LIST *list, const char *format, ...);
  
  
  //
  // send a message to a specific character
  //
! void  send_to_char (CHAR_DATA *ch, const char *format, ...);
  
  
  //
--- 44,87 ----
  void message(CHAR_DATA *ch,  CHAR_DATA *vict,
  	     OBJ_DATA  *obj, OBJ_DATA  *vobj,
  	     int hide_nosee, bitvector_t range, 
! 	     const char *mssg);
  
  
  //
  // send a message to everyone outdoors
  //
! void  send_outdoors(const char *format, ...)  
! __attribute__ ((format (printf, 1, 2)));
  
  
  //
  // send a message to a list of characters
  //
! void  send_to_list (LIST *list, const char *format, ...) 
! __attribute__ ((format (printf, 2, 3)));
  
  
  //
  // send a message to a specific character
  //
! void  send_to_char (CHAR_DATA *ch, const char *format, ...) 
! __attribute__ ((format (printf, 2, 3)));
! 
! 
! //
! // send a message to everyone at or above the specified level
! //
! void send_to_level(int level, const char *format, ...) 
! __attribute__ ((format (printf, 2, 3)));
! 
! 
! //
! // send a message to everyone in the same room as the character,
! // but not the character himself. If hide_nosee is TRUE, then the message
! // is not sent to people who cannot see the character.
! //
! void send_around_char(CHAR_DATA *ch, bool hide_nosee, const char *format, ...) 
! __attribute__ ((format (printf, 3, 4)));
  
  
  //
***************
*** 123,126 ****
--- 142,146 ----
  //
  void show_body(CHAR_DATA *ch, BODY_DATA *body);
  
+ 
  #endif // __INFORM_H
